
// Copyright (C) 2002-2011 Nikolaus Gebhardt
// This file is part of the "Irrlicht Engine".
// For conditions of distribution and use, see copyright notice in irrlicht.h

#ifndef __C_OPENGL_CONTEXT_LINUX_H_INCLUDED__
#define __C_OPENGL_CONTEXT_LINUX_H_INCLUDED__


#include "IrrCompileConfig.h"

#ifdef _IRR_COMPILE_WITH_X11_DEVICE_
#ifdef _IRR_COMPILE_WITH_OPENGL_

#include "IOpenGLContext.h"
#include <GL/gl.h>
#define GLX_GLXEXT_LEGACY 1
#include <GL/glx.h>
#ifdef _IRR_OPENGL_USE_EXTPOINTER_
#include "glxext.h"
#endif


namespace irr
{
namespace video
{




class COpenGLContextLinux : public IOpenGLContext
{
public:
    // TODO pass a window directly ?
    COpenGLContextLinux( COpenGLDriver* driver,
                        const SVideoContextConfig& contextConfig,
                        Display* display,
                         GLXContext ctx,
                         GLXDrawable glxDrawable,
                         bool externalContext
                     );

    virtual ~COpenGLContextLinux();

    virtual bool setTarget(void *data);

    virtual bool isCompatibleWithRenderWindow(IRenderWindow* ) const ;

    virtual bool swapBuffers();
    virtual void releaseContext();

    Display* X11Display;

    GLXDrawable Drawable;
//    GLXWindow glxWindow;
    GLXContext glxContext;


};

}
}

#endif // _IRR_COMPILE_WITH_OPENGL_
#endif // _IRR_COMPILE_WITH_X11_DEVICE_

#endif
