
// Copyright (C) 2002-2011 Nikolaus Gebhardt
// This file is part of the "Irrlicht Engine".
// For conditions of distribution and use, see copyright notice in irrlicht.h

#ifndef __C_SOFTWARE_CONTEXT_WIN32_H_INCLUDED__
#define __C_SOFTWARE_CONTEXT_WIN32_H_INCLUDED__


#include "IrrCompileConfig.h"

#ifdef _IRR_COMPILE_WITH_WINDOWS_DEVICE_
#ifdef _IRR_COMPILE_WITH_SOFTWARE_

#include "ISoftwareContext.h"
#include "ISoftwareContextWin32.h"

#include <windows.h>
#include <winuser.h>

namespace irr
{
namespace video
{

class IRenderWindow;
class CImage;
class CRenderWindowWin32;


class CSoftwareContextWin32 : public ISoftwareContextWin32,
                              public ISoftwareContext
{
public:
    //CRenderWindowWin32* window
    CSoftwareContextWin32(
//                          HWND ,
                          HDC,
                           IZBuffer* zBuffer, CImage* backBuffer, const SVideoContextConfig& config );
    virtual ~CSoftwareContextWin32();


    bool isCompatibleWithRenderWindow(IRenderWindow* ) const ;

    virtual bool setTarget(void* );
    virtual bool swapBuffers( core::rect<s32>* src);

    void releaseContext();

//    HWND WindowHandle;
};

}
}

#endif // _IRR_COMPILE_WITH_SOFTWARE
#endif // _IRR_COMPILE_WITH_WINDOWS_DEVICE_

#endif
